package com.agiledeveloper;

import java.util.Arrays;

public class GameOfLife {
  static final boolean ALIVE = true;
  static final boolean DEAD = false;                 

  boolean isAlive(boolean alive, int numberOfLifeNeighbors) {
    return alive && numberOfLifeNeighbors == 2 || numberOfLifeNeighbors == 3;
  }
  
  int getLiveNeighborCount(boolean[][] universe, int x, int y) {
    int count = 0;
    
    for(int i = x - 1; i <= x + 1; i++) {
      for(int j = y - 1; j <= y + 1; j++) {
        if(i == x && j == y) continue;
        
        if(isCellAliveAt(universe, i, j)) count++;
      }
    }
    
    return count;
  }
  
  private boolean isCellAliveAt(boolean[][] universe, int x, int y) {
    return x >= 0 && y >= 0 && x < universe.length && y < universe.length && universe[x][y];
  }
  
  public boolean[][] nextGeneration(boolean[][] universe) {
    boolean[][] newUniverse = new boolean[universe.length][universe.length];
    
    for(int i = 0; i < universe.length; i++) {
      for(int j = 0; j < universe.length; j++) {
        newUniverse[i][j] = isAlive(universe[i][j], 
          getLiveNeighborCount(universe, i, j));
      }
    }                  
    
    return newUniverse;
  }
}
